<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>35.10. pipes — Interface to shell pipelines &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="35. Unix Specific Services" href="unix.html" />
    <link rel="next" title="35.11. resource — Resource usage information" href="resource.html" />
    <link rel="prev" title="35.9. fcntl — The fcntl and ioctl system calls" href="fcntl.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="resource.html" title="35.11. resource — Resource usage information"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="fcntl.html" title="35.9. fcntl — The fcntl and ioctl system calls"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="unix.html" accesskey="U">35. Unix Specific Services</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-pipes">
<span id="pipes-interface-to-shell-pipelines"></span><h1>35.10. <a class="reference internal" href="#module-pipes" title="pipes: A Python interface to Unix shell pipelines. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">pipes</span></code></a> &#8212; Interface to shell pipelines<a class="headerlink" href="#module-pipes" title="Permalink to this headline">¶</a></h1>
<p><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/pipes.py">Lib/pipes.py</a></p>
<hr class="docutils" />
<p>The <a class="reference internal" href="#module-pipes" title="pipes: A Python interface to Unix shell pipelines. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">pipes</span></code></a> module defines a class to abstract the concept of a <em>pipeline</em>
&#8212; a sequence of converters from one file to  another.</p>
<p>Because the module uses <strong class="program">/bin/sh</strong> command lines, a POSIX or compatible
shell for <a class="reference internal" href="os.html#os.system" title="os.system"><code class="xref py py-func docutils literal"><span class="pre">os.system()</span></code></a> and <a class="reference internal" href="os.html#os.popen" title="os.popen"><code class="xref py py-func docutils literal"><span class="pre">os.popen()</span></code></a> is required.</p>
<p>The <a class="reference internal" href="#module-pipes" title="pipes: A Python interface to Unix shell pipelines. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">pipes</span></code></a> module defines the following class:</p>
<dl class="class">
<dt id="pipes.Template">
<em class="property">class </em><code class="descclassname">pipes.</code><code class="descname">Template</code><a class="headerlink" href="#pipes.Template" title="Permalink to this definition">¶</a></dt>
<dd><p>An abstraction of a pipeline.</p>
</dd></dl>

<p>Example:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">pipes</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">t</span> <span class="o">=</span> <span class="n">pipes</span><span class="o">.</span><span class="n">Template</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">t</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s">&#39;tr a-z A-Z&#39;</span><span class="p">,</span> <span class="s">&#39;--&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">f</span> <span class="o">=</span> <span class="n">t</span><span class="o">.</span><span class="n">open</span><span class="p">(</span><span class="s">&#39;pipefile&#39;</span><span class="p">,</span> <span class="s">&#39;w&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s">&#39;hello world&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">f</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">open</span><span class="p">(</span><span class="s">&#39;pipefile&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>
<span class="go">&#39;HELLO WORLD&#39;</span>
</pre></div>
</div>
<div class="section" id="template-objects">
<span id="id1"></span><h2>35.10.1. Template Objects<a class="headerlink" href="#template-objects" title="Permalink to this headline">¶</a></h2>
<p>Template objects following methods:</p>
<dl class="method">
<dt id="pipes.Template.reset">
<code class="descclassname">Template.</code><code class="descname">reset</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pipes.Template.reset" title="Permalink to this definition">¶</a></dt>
<dd><p>Restore a pipeline template to its initial state.</p>
</dd></dl>

<dl class="method">
<dt id="pipes.Template.clone">
<code class="descclassname">Template.</code><code class="descname">clone</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#pipes.Template.clone" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a new, equivalent, pipeline template.</p>
</dd></dl>

<dl class="method">
<dt id="pipes.Template.debug">
<code class="descclassname">Template.</code><code class="descname">debug</code><span class="sig-paren">(</span><em>flag</em><span class="sig-paren">)</span><a class="headerlink" href="#pipes.Template.debug" title="Permalink to this definition">¶</a></dt>
<dd><p>If <em>flag</em> is true, turn debugging on. Otherwise, turn debugging off. When
debugging is on, commands to be executed are printed, and the shell is given
<code class="docutils literal"><span class="pre">set</span> <span class="pre">-x</span></code> command to be more verbose.</p>
</dd></dl>

<dl class="method">
<dt id="pipes.Template.append">
<code class="descclassname">Template.</code><code class="descname">append</code><span class="sig-paren">(</span><em>cmd</em>, <em>kind</em><span class="sig-paren">)</span><a class="headerlink" href="#pipes.Template.append" title="Permalink to this definition">¶</a></dt>
<dd><p>Append a new action at the end. The <em>cmd</em> variable must be a valid bourne shell
command. The <em>kind</em> variable consists of two letters.</p>
<p>The first letter can be either of <code class="docutils literal"><span class="pre">'-'</span></code> (which means the command reads its
standard input), <code class="docutils literal"><span class="pre">'f'</span></code> (which means the commands reads a given file on the
command line) or <code class="docutils literal"><span class="pre">'.'</span></code> (which means the commands reads no input, and hence
must be first.)</p>
<p>Similarly, the second letter can be either of <code class="docutils literal"><span class="pre">'-'</span></code> (which means  the command
writes to standard output), <code class="docutils literal"><span class="pre">'f'</span></code> (which means the  command writes a file on
the command line) or <code class="docutils literal"><span class="pre">'.'</span></code> (which means the command does not write anything,
and hence must be last.)</p>
</dd></dl>

<dl class="method">
<dt id="pipes.Template.prepend">
<code class="descclassname">Template.</code><code class="descname">prepend</code><span class="sig-paren">(</span><em>cmd</em>, <em>kind</em><span class="sig-paren">)</span><a class="headerlink" href="#pipes.Template.prepend" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a new action at the beginning. See <a class="reference internal" href="#pipes.Template.append" title="pipes.Template.append"><code class="xref py py-meth docutils literal"><span class="pre">append()</span></code></a> for explanations of the
arguments.</p>
</dd></dl>

<dl class="method">
<dt id="pipes.Template.open">
<code class="descclassname">Template.</code><code class="descname">open</code><span class="sig-paren">(</span><em>file</em>, <em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#pipes.Template.open" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a file-like object, open to <em>file</em>, but read from or written to by the
pipeline.  Note that only one of <code class="docutils literal"><span class="pre">'r'</span></code>, <code class="docutils literal"><span class="pre">'w'</span></code> may be given.</p>
</dd></dl>

<dl class="method">
<dt id="pipes.Template.copy">
<code class="descclassname">Template.</code><code class="descname">copy</code><span class="sig-paren">(</span><em>infile</em>, <em>outfile</em><span class="sig-paren">)</span><a class="headerlink" href="#pipes.Template.copy" title="Permalink to this definition">¶</a></dt>
<dd><p>Copy <em>infile</em> to <em>outfile</em> through the pipe.</p>
</dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">35.10. <code class="docutils literal"><span class="pre">pipes</span></code> &#8212; Interface to shell pipelines</a><ul>
<li><a class="reference internal" href="#template-objects">35.10.1. Template Objects</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="fcntl.html"
                        title="previous chapter">35.9. <code class="docutils literal"><span class="pre">fcntl</span></code> &#8212; The <code class="docutils literal"><span class="pre">fcntl</span></code> and <code class="docutils literal"><span class="pre">ioctl</span></code> system calls</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="resource.html"
                        title="next chapter">35.11. <code class="docutils literal"><span class="pre">resource</span></code> &#8212; Resource usage information</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/pipes.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="resource.html" title="35.11. resource — Resource usage information"
             >next</a> |</li>
        <li class="right" >
          <a href="fcntl.html" title="35.9. fcntl — The fcntl and ioctl system calls"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="unix.html" >35. Unix Specific Services</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>